//Proof-of-Concept script for player-carrying dropship
//See http://community.sierra.com/cgi-bin/WebX.fcgi?14@238.heu8aArZHWJ^1@.ee82df6 for explanation
//If you want to copy this, make sure all spaceports and the fakeship are in the same orientation. Otherwise it will look very screwed up when the player boards and disembarks.

exec("multiplayerStdLib.cs");
$Server::TeamDamage=true;

function onMissionStart()
{
	$peopleInAlphaDoor=0;
	$peopleInBravoDoor=0;
	$peopleInShipDoor=0;
	$dropshipLocation= "alpha"; //air, alpha, bravo
	$dropship= getObjectId("MissionGroup\\dropship");
	initSounds();
	trackDropship();	//Needed for destruction code
        $dropshipLanding=false; //Needed to prevent landing chat repetition
}

function trackDropship()
{
	$dropshipX= getPosition($Dropship, x);
	$dropshipY= getPosition($Dropship, y);
	$dropshipZ= getPosition($Dropship, z);
	schedule("trackDropship();",0.5);
}

function initSounds()
{
	AlarmSoundsOn("MissionGroup\\launchTrigger","sfx_flyer_damaged.wav");	//Yes, I know its odd, but thats the sound the dropship makes while flying around, even if its in top condition...
	createAmbientSoundSource("MissionGroup\\Alpha base\\Airlock\\floor2", 20, 5, 10);
	addToAmbientSoundSource("MissionGroup\\Alpha base\\Airlock\\floor2", "sfx_steam.wav", IDPRF_NEAR);
	addToAmbientSoundSource("MissionGroup\\Alpha base\\Airlock\\floor2", "sfx_machine1.wav", IDPRF_NEAR);

//	createAmbientSoundSource("MissionGroup\\fakeship\\Airlock\\floor2", 20, 5, 10);
//	addToAmbientSoundSource("MissionGroup\\fakeship\\Airlock\\floor2", "sfx_steam.wav", IDPRF_NEAR);
//	addToAmbientSoundSource("MissionGroup\\fakeship\\Airlock\\floor2", "sfx_machine1.wav", IDPRF_NEAR);
}

function player::onDestroyed(%destroyee, %destroyer)
{
	setVehicleRadarVisible( %destroyee, true );	//Just in case they were in the dropship
}

//All those hatches
function adoor::trigger::onEnter(%this, %vehicleId)
{
	if ($dropshipLocation!="alpha")
	{say(0,playerManager::vehicleIdToPlayerNum(%vehicleId),"No ship is currently docked. Please wait."); $peopleInAlphaDoor = $peopleInAlphaDoor + 1; return;} //person counted to prevent a bug when he/she leaves
	if($peopleInAlphaDoor == 0)
	{
		playAnimSequence(getObjectId("MissionGroup\\Alpha base\\Airlock\\hatch1"), 0, true);
	}
	$peopleInAlphaDoor = $peopleInAlphaDoor + 1;
}

function adoor::trigger::onLeave(%this, %vehicleId)
{
	$peopleInAlphaDoor = $peopleInAlphaDoor - 1;
	if($peopleInAlphaDoor == 0)
	{
		playAnimSequence(getObjectId("MissionGroup\\Alpha base\\Airlock\\hatch1"), 0, false);
	}
}

function bdoor::trigger::onEnter(%this, %vehicleId)
{
	if ($dropshipLocation!="bravo")
	{say(0,playerManager::vehicleIdToPlayerNum(%vehicleId),"No ship is currently docked. Please wait."); 	$peopleInBravoDoor = $peopleInBravoDoor + 1; return;} //person counted to prevent a bug when he/she leaves
	if($peopleInBravoDoor == 0)
	{
		playAnimSequence(getObjectId("MissionGroup\\Bravo base\\Airlock\\hatch1"), 0, true);
	}
	$peopleInBravoDoor = $peopleInBravoDoor + 1;
}

function bdoor::trigger::onLeave(%this, %vehicleId)
{
	$peopleInBravoDoor = $peopleInBravoDoor - 1;
	if($peopleInAlphaDoor == 0)
	{
		playAnimSequence(getObjectId("MissionGroup\\Bravo base\\Airlock\\hatch1"), 0, false);
	}
}


function sdoor::trigger::onEnter(%this, %vehicleId)
{
	if ($dropshipLocation=="air")
	{say(0,playerManager::vehicleIdToPlayerNum(%vehicleId),"<F5>WARNING: THE DROPSHIP IS AIRBORNE! DROPSHIP DOORS HAVE BEEN DEACTIVATED"); $peopleInShipDoor = $peopleInShipDoor + 1; return;} //person counted to prevent a bug when he/she leaves
	if($peopleInShipDoor == 0)
	{
		playAnimSequence(getObjectId("MissionGroup\\fakeShip\\Airlock\\hatch1"), 0, true);
	}
	$peopleInShipDoor = $peopleInShipDoor + 1;
}

function sdoor::trigger::onLeave(%this, %vehicleId)
{
	$peopleInShipDoor = $peopleInShipDoor - 1;
	if($peopleInShipDoor == 0)
	{
		playAnimSequence(getObjectId("MissionGroup\\fakeShip\\Airlock\\hatch1"), 0, false);
	}
}

//Room teleports
function shipTeleport::trigger::onEnter(%this, %vehicle)
{
	echo("PLAYER LEAVING SHIP");
	setVehicleRadarVisible( %vehicle, true );
	if ($dropshipLocation=="alpha")
	{
	setPosition(%vehicle, getPosition(%vehicle,x) -getPosition("MissionGroup\\fakeship\\airlock\\deadDoors",x) +getPosition("MissionGroup\\Alpha base\\airlock\\hatch1",x), getPosition(%vehicle,y) -getPosition("MissionGroup\\fakeship\\airlock\\deadDoors",y) +getPosition("MissionGroup\\Alpha base\\airlock\\hatch1",y), getPosition(%vehicle,z) -getPosition("MissionGroup\\fakeship\\airlock\\deadDoors",z) +getPosition("MissionGroup\\Alpha base\\airlock\\hatch1",z));
	}
	if ($dropshipLocation=="bravo")
	{
	setPosition(%vehicle, getPosition(%vehicle,x) -getPosition("MissionGroup\\fakeship\\airlock\\deadDoors",x) +getPosition("MissionGroup\\Bravo base\\airlock\\hatch1",x), getPosition(%vehicle,y) -getPosition("MissionGroup\\fakeship\\airlock\\deadDoors",y) +getPosition("MissionGroup\\Bravo base\\airlock\\hatch1",y), getPosition(%vehicle,z) -getPosition("MissionGroup\\fakeship\\airlock\\deadDoors",z) +getPosition("MissionGroup\\Bravo base\\airlock\\hatch1",z));
	}
	echo("PLAYER LEFT SHIP");
}

function alphaTeleport::trigger::onEnter(%this, %vehicle)
{
	echo("PLAYER ENTERING SHIP");
	setVehicleRadarVisible( %vehicle, false );
        setPosition(%vehicle, getPosition(%vehicle,x) -getPosition("MissionGroup\\Alpha base\\Airlock\\deadDoors",x) +getPosition("MissionGroup\\fakeship\\airlock\\hatch1",x), getPosition(%vehicle,y) -getPosition("MissionGroup\\Alpha base\\Airlock\\deadDoors",y) +getPosition("MissionGroup\\fakeship\\airlock\\hatch1",y), getPosition(%vehicle,z) -getPosition("MissionGroup\\Alpha base\\Airlock\\deadDoors",z) +getPosition("MissionGroup\\fakeship\\airlock\\hatch1",z) ); //Depends on vehicle's location relative to airlock
	echo("PLAYER ENTERED SHIP");
}

function bravoTeleport::trigger::onEnter(%this, %vehicle)
{
	echo("PLAYER ENTERING SHIP");
	setVehicleRadarVisible( %vehicle, false );
        setPosition(%vehicle, getPosition(%vehicle,x) -getPosition("MissionGroup\\Bravo base\\Airlock\\deadDoors",x) +getPosition("MissionGroup\\fakeship\\airlock\\hatch1",x), getPosition(%vehicle,y) -getPosition("MissionGroup\\Bravo base\\Airlock\\deadDoors",y) +getPosition("MissionGroup\\fakeship\\airlock\\hatch1",y), getPosition(%vehicle,z) -getPosition("MissionGroup\\Bravo base\\Airlock\\deadDoors",z) +getPosition("MissionGroup\\fakeship\\airlock\\hatch1",z) );
	echo("PLAYER ENTERED SHIP");
}

//Teleporter Network; this is so you can quickly bypass the dropship
function alphaWarp::trigger::onEnter(%this, %vehicleId)
{
	setPosition(%vehicleId, 3371.2, -412.071, getTerrainHeight(3371.2, -412.071)+5);	//Go to Bravo base
}

function bravoWarp::trigger::onEnter(%this, %vehicleId)
{
	setPosition(%vehicleId, 34.83, 143.677, getTerrainHeight(34.83, 143.677)+5);		//Go to the shooting range
}

function charlieWarp::trigger::onEnter(%this, %vehicleId)
{
	setPosition(%vehicleId, -6777.47, -89.6767, getTerrainHeight(-6777.47, -89.6767)+5);	//Go to Alpha base
}

//Dropship operation
function thedropship::vehicle::onArrived(%who, %where)
{
	if (%where==getObjectId("MissionGroup\\AlphatoBravo\\landingpad"))
                {
		order($dropship, clear, true);
		order($dropship, guard, "MissionGroup\\AlphatoBravo\\landingpad");
		//While landing, the dropship will pass through the point twice. This next line causes the messages to only be displayed the first time
		if ($dropshipLanding==false)
			{
			$dropshipLanding=true;
			schedule("dropshipChat(\"The dropship has arrived at Bravo base\");",30);
			schedule("bravoChat(\"The dropship has arrived!\");",30);
			schedule("dropShipChat(\"sfx_flyer_off.wav\");",25);
                        schedule("$dropshipLocation=\"bravo\";",30);    //Landing sequence takes 30 seconds
                        dropshipChat("gen_2dsa06.wav");       //countdown initiated for final approach
			schedule("$dropshipLanding=false;",40);
			}
		}
	if (%where==getObjectId("MissionGroup\\BravotoAlpha\\landingpad"))
                {
		order($dropship, clear, true);
		order($dropship, guard, "MissionGroup\\BravotoAlpha\\landingpad");
		//say(0,0,"DEBUG: landing at alpha complete");
		//While landing, the dropship will pass through the point twice. This next line causes the messages to only be displayed the first time
		if ($dropshipLanding==false)
			{
			$dropshipLanding=true;
			schedule("dropshipChat(\"The dropship has arrived at Alpha base\");",30);
			schedule("alphaChat(\"The dropship has arrived!\");",30);
			schedule("dropShipChat(\"sfx_flyer_off.wav\");",25);
                        schedule("$dropshipLocation=\"alpha\";",30);    //Landing sequence takes 30 seconds
                        dropshipChat("gen_2dsa06.wav");       //countdown initiated for final approach
			schedule("$dropshipLanding=false;",40);
			}
		}
}

function thedropship::vehicle::onDestroyed(%destroyee, %destroyer)
{
	%playerCount = playerManager::getPlayerCount();
	for(%i=0; %i < %playerCount ; %i++)
     	{
     	%player = playerManager::getPlayerNum( %i );
	%vehicle= playerManager::playerNumToVehicleId(%player);
	if (getPosition(%vehicle,z)>2000)
		%damage=randomInt(15000,50000);
		setVehicleRadarVisible( %vehicle, true );
		setPosition(%vehicle, $dropshipX, $dropshipY,$dropshipZ);
		schedule("damageObject("@%vehicle@","@%damage@");",0.2);	//Passengers get heavy damage
		say(0,%player,"explosionlarge.wav");
	}
//	schedule("dungatsCloneVehicle(\"$Dropship\",%destroyee,%x,%y,%z);",30);	//Dropship recloned after 30 seconds...
//	schedule"order($Dropship, guard, getObjectId(\"MissionGroup\\BravotoAlpha\\landingpad\"));",35);
}

//The dropship interior is a staticInterior object; therefore it is not possible to target anything located inside.
function launchTrigger::structure::onAttacked(%attackee, %attacker)
{
	if ($dropshipLocation=="air") return;
	dropshipChat("<F4>Initiating launch sequence... the trip should take about 4 minutes");
	if ($DropshipLocation=="alpha")
		{order($dropship, guard, "MissionGroup\\AlphatoBravo");}
	if ($DropshipLocation=="bravo")
		{order($dropship, guard, "MissionGroup\\BravotoAlpha");}
	$dropshipLocation="air";
	dropShipChat("sfx_flyer_on.wav");
	dropshipChat("gen_2dsa07.wav");		//takeoff sequence initiated
	//setOrbitCamera($dropship,80, 0,30);   //For debugging purposes
}

function dropshipChat(%string)          //sends %string to everybody inside the dropship or the top airlock
{
	%playerCount = playerManager::getPlayerCount();
	for(%i=0; %i < %playerCount ; %i++)
     	{
     	%player = playerManager::getPlayerNum( %i );
	%vehicle= playerManager::playerNumToVehicleId(%player);
	if (getPosition(%vehicle,z)>2000)
		say(0,%player,%string);
	}
}

function alphaChat(%string)		//sends %string to everybody near Alpha base
{
	%playerCount = playerManager::getPlayerCount();
	for(%i=0; %i < %playerCount ; %i++)
     	{
     	%player = playerManager::getPlayerNum( %i );
	%vehicle= playerManager::playerNumToVehicleId(%player);
	if (getDistance(%vehicle, getObjectId("MissionGroup\\Alpha base\\navMarker"))<1000)
		say(0,%player,%string);
	}
}

function bravoChat(%string)		//sends %string to everybody near Bravo base
{
	%playerCount = playerManager::getPlayerCount();
	for(%i=0; %i < %playerCount ; %i++)
     	{
     	%player = playerManager::getPlayerNum( %i );
	%vehicle= playerManager::playerNumToVehicleId(%player);
	if (getDistance(%vehicle, getObjectId("MissionGroup\\Bravo base\\navMarker"))<1000)
		say(0,%player,%string);
	}
}

function dungatsCloneVehicle(%globalVarName, %old, %x, %y, %z)
{
   %clone = cloneVehicle(%old);
   setPosition(%clone, %x, %y, %z);

   schedule( "deleteObject(" @ %old @ ");", 40);

   schedule( %globalVarName @ " = " @ %clone @ ";", 0);

   addToSet( "MissionGroup", %clone );
}
